const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x, y;
let v ;
let f=1 ;
let av;
let dv ;
let r ,l,m;
let a,b,c,e,ee,p;
let buffer = null;
let d = { width: canvas.width, height: canvas.height };

function init() {
    d = { width: canvas.width, height: canvas.height };
    v = 0;
    f = 1;
    av = 3;
    dv = av;
    r = 10;
	l=240;
	m=3;
	a=1000;
	b=1000;
	c=1;e=1;ee=1;
    buffer = createBuffer(d.width, d.height);
    drawToBuffer();
}


function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
    g.fillStyle = "white";
    g.fillRect(0, 30, d.width, d.height - 30);
    g.strokeStyle = "black";
    g.beginPath();
    g.moveTo(0, (d.height / 2));
    g.lineTo(200+(2*m+c)*l/4, (d.height / 2) );
    g.stroke();
	if (e==1){	g.fillStyle = "yellow";}
	if (e==-1){	g.fillStyle = "gray";}	
    g.fillRect(200+(2*m+c)*l/4,30, 50, d.height );


	
	for (x = 198; x >= 0; x -= r) {//左向き進行波
    y = (d.height / 6) * Math.sin((x + v - 200+2) * 2 * Math.PI / l) + (d.height / 2);
    if (x === 200) {
        g.fillStyle = "black";
    } else {
        g.fillStyle = "blue";
    }
    g.beginPath();
    g.arc(x, y, r / 2, 0, Math.PI * 2);
    g.fill();
}


    for (x =200+(2*m+c)*l/4; x >=0; x = x - r) {//反射波
        y =  e*(d.height / 6) *Math.sin((v+x-200-2*(2*m+c)*l/4) * 2 * Math.PI / l )+ (d.height / 2)+a;
		g.fillStyle = "lightgreen" ;	
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
        
       
    }
	for (x = 200; x <=200+(2*m+c)*l/4; x = x + r) {//入射波
        y = (d.height / 6) * Math.sin((-x + v+200) * Math.PI *2/ l)+ (d.height / 2);
		if(x==200)
        g.fillStyle = "black" ;
	    else
		g.fillStyle = "blue" ;	
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
    }
	for (x = 200; x >=0; x = x - r) {//進行合成波
        y = b+e*(d.height / 6) * Math.sin((x + v-200-2*(2*m+c)*l/4) * Math.PI *2/ l)+ 
		(d.height / 6)* Math.sin((x + v-200)*Math.PI *2/ l)+(d.height / 2);
		g.fillStyle = "red" ;
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
    }
	for (x = 200; x <=200+(2*m+c)*l/4; x = x +r) {//定常波
        y = b+e*(d.height / 6) * Math.sin((x + v-200-2*(2*m+c)*l/4) * Math.PI *2/ l)+ 
		(d.height / 6)* Math.sin((-x + v+200)*Math.PI *2/ l)+(d.height / 2);
		g.fillStyle = "red" ;
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
    }
}

function move() {
    dv = f * av;
    v = v + dv;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
}

document.getElementById('free').addEventListener('click', free);
document.getElementById('fixed').addEventListener('click', fixed);
document.getElementById('distance1').addEventListener('click', distance1);
document.getElementById('distance2').addEventListener('click', distance2);
document.getElementById('distance3').addEventListener('click', distance3);
document.getElementById('inci').addEventListener('click', inci);
document.getElementById('ref').addEventListener('click', ref);
document.getElementById('compo').addEventListener('click', compo);
document.getElementById('sh').addEventListener('click', sh);
//document.getElementById('sm').addEventListener('click', sm);
document.getElementById('sl').addEventListener('click', sl);
//document.getElementById('sS').addEventListener('click', sS);
//document.getElementById('sL').addEventListener('click', sL);
document.getElementById('stop').addEventListener('click', stop);
document.getElementById('run').addEventListener('click', run);


function free() {
       // c=1;
		e=1;
}
function fixed() {
      // c=2;
		e=-1;
}
function distance1() {
        c=1;
		//ee=1;
		//e=1;
}
function distance2() {
      c=1.5;
	  //p=-1;
		//e=1;
}
function distance3() {
      c=2;
	  //ee=-1;
		//e=1;
}
function inci() {
        a=1000;
		b=1000;
}
function ref() {
        a=0;
		b=1000;
}
function compo() {
        a=0;
		b=0;
}

function sh() {
	
        av=3;
}
function sl(){
        av=1.5;
}

function stop() {
        av=0;
}
function run() {
        av=3;
}


init();
start();




